> ## Documentation Index
> Fetch the complete documentation index at: https://docs.outlit.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Ingest customer activity events



## OpenAPI

````yaml /openapi.json post /api/i/v1/{publicKey}/events
openapi: 3.1.0
info:
  title: Outlit Public API
  version: 1.0.0
  description: >-
    Generated from Outlit Core's capability catalog and public protocol
    transport contracts.
servers:
  - url: https://app.outlit.ai
security:
  - bearerAuth: []
paths:
  /api/i/v1/{publicKey}/events:
    post:
      summary: Ingest customer activity events
      operationId: ingestEvents
      parameters:
        - name: publicKey
          in: path
          required: true
          schema:
            type: string
            minLength: 1
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/IngestPayload'
      responses:
        '200':
          description: Ingestion result
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IngestResponse'
        '207':
          description: Partial ingestion result
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IngestResponse'
        '400':
          description: Invalid ingestion request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IngestResponse'
        '500':
          description: Ingestion failure
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/IngestResponse'
      security: []
components:
  schemas:
    IngestPayload:
      type: object
      properties:
        visitorId:
          type: string
          format: uuid
          pattern: >-
            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
        fingerprint:
          type: string
          minLength: 1
        source:
          default: client
          type: string
          enum:
            - client
            - server
            - integration
        events:
          minItems: 1
          maxItems: 100
          type: array
          items:
            oneOf:
              - type: object
                properties:
                  uuid:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    const: pageview
                  timestamp:
                    type: number
                  url:
                    type: string
                    format: uri
                  path:
                    type: string
                  referrer:
                    type: string
                  utm:
                    type: object
                    properties:
                      source:
                        type: string
                      medium:
                        type: string
                      campaign:
                        type: string
                      term:
                        type: string
                      content:
                        type: string
                      ref:
                        type: string
                  customerId:
                    type: string
                    minLength: 1
                  customerTraits:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                  title:
                    type: string
                required:
                  - type
                  - timestamp
                  - url
                  - path
                additionalProperties: false
              - type: object
                properties:
                  uuid:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    const: form
                  timestamp:
                    type: number
                  url:
                    type: string
                    format: uri
                  path:
                    type: string
                  referrer:
                    type: string
                  utm:
                    type: object
                    properties:
                      source:
                        type: string
                      medium:
                        type: string
                      campaign:
                        type: string
                      term:
                        type: string
                      content:
                        type: string
                      ref:
                        type: string
                  customerId:
                    type: string
                    minLength: 1
                  customerTraits:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                  formId:
                    type: string
                  formFields:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      type: string
                required:
                  - type
                  - timestamp
                  - url
                  - path
                additionalProperties: false
              - type: object
                properties:
                  uuid:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    const: identify
                  timestamp:
                    type: number
                  url:
                    type: string
                    format: uri
                  path:
                    type: string
                  referrer:
                    type: string
                  utm:
                    type: object
                    properties:
                      source:
                        type: string
                      medium:
                        type: string
                      campaign:
                        type: string
                      term:
                        type: string
                      content:
                        type: string
                      ref:
                        type: string
                  email:
                    type: string
                    format: email
                    pattern: >-
                      ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
                  userId:
                    type: string
                    minLength: 1
                  fingerprint:
                    type: string
                    minLength: 1
                  customerId:
                    type: string
                    minLength: 1
                  customerTraits:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                  traits:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                required:
                  - type
                  - timestamp
                  - url
                  - path
                additionalProperties: false
              - type: object
                properties:
                  uuid:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    const: custom
                  timestamp:
                    type: number
                  url:
                    type: string
                    format: uri
                  path:
                    type: string
                  referrer:
                    type: string
                  utm:
                    type: object
                    properties:
                      source:
                        type: string
                      medium:
                        type: string
                      campaign:
                        type: string
                      term:
                        type: string
                      content:
                        type: string
                      ref:
                        type: string
                  customerId:
                    type: string
                    minLength: 1
                  customerTraits:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                  email:
                    type: string
                    format: email
                    pattern: >-
                      ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
                  userId:
                    type: string
                    minLength: 1
                  fingerprint:
                    type: string
                    minLength: 1
                  eventName:
                    type: string
                  properties:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties: {}
                required:
                  - type
                  - timestamp
                  - url
                  - path
                  - eventName
                additionalProperties: false
              - type: object
                properties:
                  uuid:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    const: calendar
                  timestamp:
                    type: number
                  url:
                    type: string
                    format: uri
                  path:
                    type: string
                  referrer:
                    type: string
                  utm:
                    type: object
                    properties:
                      source:
                        type: string
                      medium:
                        type: string
                      campaign:
                        type: string
                      term:
                        type: string
                      content:
                        type: string
                      ref:
                        type: string
                  customerId:
                    type: string
                    minLength: 1
                  customerTraits:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                  provider:
                    type: string
                    enum:
                      - cal.com
                      - calendly
                      - unknown
                  eventType:
                    type: string
                  startTime:
                    type: string
                  endTime:
                    type: string
                  duration:
                    type: number
                  isRecurring:
                    type: boolean
                  inviteeEmail:
                    type: string
                    format: email
                    pattern: >-
                      ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
                  inviteeName:
                    type: string
                required:
                  - type
                  - timestamp
                  - url
                  - path
                  - provider
                additionalProperties: false
              - type: object
                properties:
                  uuid:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                  type:
                    type: string
                    const: engagement
                  timestamp:
                    type: number
                  url:
                    type: string
                    format: uri
                  path:
                    type: string
                  referrer:
                    type: string
                  utm:
                    type: object
                    properties:
                      source:
                        type: string
                      medium:
                        type: string
                      campaign:
                        type: string
                      term:
                        type: string
                      content:
                        type: string
                      ref:
                        type: string
                  customerId:
                    type: string
                    minLength: 1
                  customerTraits:
                    type: object
                    propertyNames:
                      type: string
                    additionalProperties:
                      anyOf:
                        - type: string
                        - type: number
                        - type: boolean
                        - type: 'null'
                  activeTimeMs:
                    type: number
                  totalTimeMs:
                    type: number
                  sessionId:
                    type: string
                    format: uuid
                    pattern: >-
                      ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
                required:
                  - type
                  - timestamp
                  - url
                  - path
                  - activeTimeMs
                  - totalTimeMs
                  - sessionId
                additionalProperties: false
        sessionId:
          type: string
          format: uuid
          pattern: >-
            ^([0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[1-8][0-9a-fA-F]{3}-[89abAB][0-9a-fA-F]{3}-[0-9a-fA-F]{12}|00000000-0000-0000-0000-000000000000|ffffffff-ffff-ffff-ffff-ffffffffffff)$
        userIdentity:
          type: object
          properties:
            email:
              type: string
              format: email
              pattern: >-
                ^(?!\.)(?!.*\.\.)([A-Za-z0-9_'+\-\.]*)[A-Za-z0-9_+-]@([A-Za-z0-9][A-Za-z0-9\-]*\.)+[A-Za-z]{2,}$
            userId:
              type: string
              minLength: 1
            fingerprint:
              type: string
              minLength: 1
            traits:
              type: object
              propertyNames:
                type: string
              additionalProperties:
                anyOf:
                  - type: string
                  - type: number
                  - type: boolean
                  - type: 'null'
          additionalProperties: false
        customerIdentity:
          type: object
          properties:
            customerId:
              type: string
              minLength: 1
            customerTraits:
              type: object
              propertyNames:
                type: string
              additionalProperties:
                anyOf:
                  - type: string
                  - type: number
                  - type: boolean
                  - type: 'null'
          additionalProperties: false
      required:
        - events
    IngestResponse:
      type: object
      properties:
        success:
          type: boolean
        processed:
          type: integer
          minimum: 0
          maximum: 9007199254740991
        errors:
          type: array
          items:
            type: object
            properties:
              index:
                type: integer
                minimum: -9007199254740991
                maximum: 9007199254740991
              message:
                type: string
            required:
              - index
              - message
            additionalProperties: false
      required:
        - success
        - processed
      additionalProperties: false
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: Outlit API key (ok_...).

````